'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var PropTypes = require('prop-types');
var TopologyType = require('../models/topology-type');
var Single = require('./single');
var Sharded = require('./sharded');
var ReplicaSet = require('./replica-set');
var Unknown = require('./unknown');

/**
 * The deployment awareness component.
 */

var DeploymentAwarenessComponent = function (_React$Component) {
  _inherits(DeploymentAwarenessComponent, _React$Component);

  function DeploymentAwarenessComponent() {
    _classCallCheck(this, DeploymentAwarenessComponent);

    return _possibleConstructorReturn(this, (DeploymentAwarenessComponent.__proto__ || Object.getPrototypeOf(DeploymentAwarenessComponent)).apply(this, arguments));
  }

  _createClass(DeploymentAwarenessComponent, [{
    key: 'renderTopologyInfo',


    /**
     * Renders the topology information.
     *
     * @returns {React.Component} The component.
     */
    value: function renderTopologyInfo() {
      switch (this.props.topologyType) {
        case TopologyType.SINGLE:
          return React.createElement(Single, { server: this.props.servers[0] });
        case TopologyType.SHARDED:
          return React.createElement(Sharded, { servers: this.props.servers });
        case TopologyType.REPLICA_SET_NO_PRIMARY:
        case TopologyType.REPLICA_SET_WITH_PRIMARY:
          return React.createElement(ReplicaSet, this.props);
        default:
          return React.createElement(Unknown, { servers: this.props.servers });
      }
    }

    /**
     * Render DeploymentAwareness component.
     *
     * @returns {React.Component} The rendered component.
     */

  }, {
    key: 'render',
    value: function render() {
      return React.createElement(
        'div',
        { className: 'topology' },
        this.renderTopologyInfo()
      );
    }
  }]);

  return DeploymentAwarenessComponent;
}(React.Component);

DeploymentAwarenessComponent.propTypes = {
  servers: PropTypes.array,
  setName: PropTypes.string,
  topologyType: PropTypes.string
};

DeploymentAwarenessComponent.displayName = 'DeploymentAwarenessComponent';

module.exports = DeploymentAwarenessComponent;